"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  pluginPreview: () => pluginPreview
});
module.exports = __toCommonJS(src_exports);
var import_path4 = require("path");
var import_node_net = __toESM(require("net"));
var import_shared3 = require("@rspress/shared");
var import_core = require("@rsbuild/core");
var import_plugin_solid = require("@rsbuild/plugin-solid");
var import_plugin_babel = require("@rsbuild/plugin-babel");
var import_plugin_react = require("@rsbuild/plugin-react");
var import_lodash = require("lodash");

// src/remarkPlugin.ts
var import_path2 = require("path");

// ../../node_modules/.pnpm/unist-util-is@5.2.1/node_modules/unist-util-is/lib/index.js
var convert = (
  /**
   * @type {(
   *   (<Kind extends Node>(test: PredicateTest<Kind>) => AssertPredicate<Kind>) &
   *   ((test?: Test) => AssertAnything)
   * )}
   */
  /**
   * @param {Test} [test]
   * @returns {AssertAnything}
   */
  function(test) {
    if (test === void 0 || test === null) {
      return ok;
    }
    if (typeof test === "string") {
      return typeFactory(test);
    }
    if (typeof test === "object") {
      return Array.isArray(test) ? anyFactory(test) : propsFactory(test);
    }
    if (typeof test === "function") {
      return castFactory(test);
    }
    throw new Error("Expected function, string, or object as test");
  }
);
function anyFactory(tests) {
  const checks = [];
  let index = -1;
  while (++index < tests.length) {
    checks[index] = convert(tests[index]);
  }
  return castFactory(any);
  function any(...parameters) {
    let index2 = -1;
    while (++index2 < checks.length) {
      if (checks[index2].call(this, ...parameters))
        return true;
    }
    return false;
  }
}
function propsFactory(check) {
  return castFactory(all);
  function all(node) {
    let key;
    for (key in check) {
      if (node[key] !== check[key])
        return false;
    }
    return true;
  }
}
function typeFactory(check) {
  return castFactory(type);
  function type(node) {
    return node && node.type === check;
  }
}
function castFactory(check) {
  return assertion;
  function assertion(node, ...parameters) {
    return Boolean(
      node && typeof node === "object" && "type" in node && // @ts-expect-error: fine.
      Boolean(check.call(this, node, ...parameters))
    );
  }
}
function ok() {
  return true;
}

// ../../node_modules/.pnpm/unist-util-visit-parents@5.1.3/node_modules/unist-util-visit-parents/lib/color.js
function color(d) {
  return "\x1B[33m" + d + "\x1B[39m";
}

// ../../node_modules/.pnpm/unist-util-visit-parents@5.1.3/node_modules/unist-util-visit-parents/lib/index.js
var CONTINUE = true;
var EXIT = false;
var SKIP = "skip";
var visitParents = (
  /**
   * @type {(
   *   (<Tree extends Node, Check extends Test>(tree: Tree, test: Check, visitor: BuildVisitor<Tree, Check>, reverse?: boolean | null | undefined) => void) &
   *   (<Tree extends Node>(tree: Tree, visitor: BuildVisitor<Tree>, reverse?: boolean | null | undefined) => void)
   * )}
   */
  /**
   * @param {Node} tree
   * @param {Test} test
   * @param {Visitor<Node>} visitor
   * @param {boolean | null | undefined} [reverse]
   * @returns {void}
   */
  function(tree, test, visitor, reverse) {
    if (typeof test === "function" && typeof visitor !== "function") {
      reverse = visitor;
      visitor = test;
      test = null;
    }
    const is2 = convert(test);
    const step = reverse ? -1 : 1;
    factory(tree, void 0, [])();
    function factory(node, index, parents) {
      const value = node && typeof node === "object" ? node : {};
      if (typeof value.type === "string") {
        const name = (
          // `hast`
          typeof value.tagName === "string" ? value.tagName : (
            // `xast`
            typeof value.name === "string" ? value.name : void 0
          )
        );
        Object.defineProperty(visit2, "name", {
          value: "node (" + color(node.type + (name ? "<" + name + ">" : "")) + ")"
        });
      }
      return visit2;
      function visit2() {
        let result = [];
        let subresult;
        let offset;
        let grandparents;
        if (!test || is2(node, index, parents[parents.length - 1] || null)) {
          result = toResult(visitor(node, parents));
          if (result[0] === EXIT) {
            return result;
          }
        }
        if (node.children && result[0] !== SKIP) {
          offset = (reverse ? node.children.length : -1) + step;
          grandparents = parents.concat(node);
          while (offset > -1 && offset < node.children.length) {
            subresult = factory(node.children[offset], offset, grandparents)();
            if (subresult[0] === EXIT) {
              return subresult;
            }
            offset = typeof subresult[1] === "number" ? subresult[1] : offset + step;
          }
        }
        return result;
      }
    }
  }
);
function toResult(value) {
  if (Array.isArray(value)) {
    return value;
  }
  if (typeof value === "number") {
    return [CONTINUE, value];
  }
  return [value];
}

// ../../node_modules/.pnpm/unist-util-visit@4.1.1/node_modules/unist-util-visit/index.js
var visit = (
  /**
   * @type {(
   *   (<Tree extends Node, Check extends Test>(tree: Tree, test: Check, visitor: import('./complex-types.js').BuildVisitor<Tree, Check>, reverse?: boolean) => void) &
   *   (<Tree extends Node>(tree: Tree, visitor: import('./complex-types.js').BuildVisitor<Tree>, reverse?: boolean) => void)
   * )}
   */
  /**
   * @param {Node} tree
   * @param {Test} test
   * @param {import('./complex-types.js').Visitor} visitor
   * @param {boolean} [reverse]
   */
  function(tree, test, visitor, reverse) {
    if (typeof test === "function" && typeof visitor !== "function") {
      reverse = visitor;
      visitor = test;
      test = null;
    }
    visitParents(tree, test, overload, reverse);
    function overload(node, parents) {
      const parent = parents[parents.length - 1];
      return visitor(
        node,
        parent ? parent.children.indexOf(node) : null,
        parent
      );
    }
  }
);

// src/remarkPlugin.ts
var import_shared2 = require("@rspress/shared");
var import_fs_extra = __toESM(require("@rspress/shared/fs-extra"));

// src/utils.ts
var toValidVarName = (str) => {
  if (/^[a-zA-Z_$][0-9a-zA-Z_$]*$/.test(str)) {
    return str;
  }
  return str.replace(/[^0-9a-zA-Z_$]/g, "_").replace(/^([0-9])/, "_$1");
};
var generateId = (pageName, index) => {
  return `_${toValidVarName(pageName)}_${index}`;
};
var injectDemoBlockImport = (str, path2) => {
  return `
    import DemoBlock from ${JSON.stringify(path2)};
    ${str}
  `;
};

// src/constant.ts
var import_path = __toESM(require("path"));
var import_shared = require("@rspress/shared");
var staticPath = import_path.default.join(__dirname, "..", "static");
var demoBlockComponentPath = import_path.default.join(
  staticPath,
  "global-components",
  "DemoBlock.tsx"
);
var virtualDir = import_path.default.join(
  process.cwd(),
  "node_modules",
  import_shared.RSPRESS_TEMP_DIR,
  "virtual-demo"
);

// src/ast-helpers.ts
var getASTNodeImport = (name, from) => ({
  type: "mdxjsEsm",
  value: `import ${name} from ${JSON.stringify(from)}`,
  data: {
    estree: {
      type: "Program",
      sourceType: "module",
      body: [
        {
          type: "ImportDeclaration",
          specifiers: [
            {
              type: "ImportDefaultSpecifier",
              local: { type: "Identifier", name }
            }
          ],
          source: {
            type: "Literal",
            value: from,
            raw: `${JSON.stringify(from)}`
          }
        }
      ]
    }
  }
});
var getExternalDemoContent = (tempVar) => ({
  /**
   * We create a empty parent node here. If we don't do this, the `pre` tag won't be rendered as our custom mdx component and will be rendered as a normal `pre` tag, which will cause the code block to be displayed incorrectly.
   */
  type: "mdxJsxFlowElement",
  name: "",
  attributes: [],
  children: [
    {
      type: "mdxJsxFlowElement",
      name: "pre",
      attributes: [],
      children: [
        {
          type: "mdxJsxFlowElement",
          name: "code",
          attributes: [
            {
              type: "mdxJsxAttribute",
              name: "className",
              value: "language-tsx"
            },
            {
              type: "mdxJsxAttribute",
              name: "children",
              value: {
                type: "mdxJsxExpressionAttribute",
                value: tempVar,
                data: {
                  estree: {
                    type: "Program",
                    body: [
                      {
                        type: "ExpressionStatement",
                        expression: {
                          type: "Identifier",
                          name: tempVar
                        }
                      }
                    ]
                  }
                }
              }
            }
          ]
        }
      ]
    }
  ]
});

// src/remarkPlugin.ts
var demos = {};
var remarkCodeToDemo = function({
  getRouteMeta,
  previewMode,
  defaultRenderMode,
  position,
  previewLanguages,
  previewCodeTransform
}) {
  const routeMeta2 = getRouteMeta();
  import_fs_extra.default.ensureDirSync(virtualDir);
  const data = this.data();
  return (tree, vfile) => {
    const demoMdx = [];
    const route = routeMeta2.find(
      (meta) => (0, import_shared2.normalizePosixPath)(meta.absolutePath) === (0, import_shared2.normalizePosixPath)(vfile.path || vfile.history[0])
    );
    if (!route) {
      return;
    }
    const { pageName } = route;
    demos[pageName] = [];
    let title = pageName;
    let index = 1;
    let externalDemoIndex = 0;
    function constructDemoNode(demoId, demoPath, currentNode, isMobileMode, externalDemoIndex2) {
      if (isMobileMode) {
        const relativePathReg = new RegExp(/^\.\.?\/.*$/);
        demos[pageName].push({
          title,
          id: demoId,
          path: relativePathReg.test(demoPath) ? (0, import_path2.resolve)(vfile.dirname || (0, import_path2.dirname)(vfile.path), demoPath) : demoPath
        });
      } else {
        demoMdx.push(getASTNodeImport(`Demo${demoId}`, demoPath));
      }
      const tempVar = `externalDemoContent${externalDemoIndex2}`;
      if (externalDemoIndex2 !== void 0) {
        demoMdx.push(getASTNodeImport(tempVar, `!!${demoPath}?raw`));
      }
      if (isMobileMode && position === "fixed") {
        externalDemoIndex2 !== void 0 && Object.assign(currentNode, getExternalDemoContent(tempVar));
      } else {
        Object.assign(currentNode, {
          type: "mdxJsxFlowElement",
          name: "Container",
          attributes: [
            {
              type: "mdxJsxAttribute",
              name: "isMobile",
              value: isMobileMode
            },
            {
              type: "mdxJsxAttribute",
              name: "demoId",
              value: demoId
            }
          ],
          children: [
            externalDemoIndex2 === void 0 ? {
              ...currentNode,
              hasVisited: true
            } : getExternalDemoContent(tempVar),
            isMobileMode ? {
              type: "mdxJsxFlowElement",
              name: null
            } : {
              type: "mdxJsxFlowElement",
              name: `Demo${demoId}`
            }
          ]
        });
      }
    }
    visit(tree, "heading", (node) => {
      if (node.depth === 1) {
        if (node.children) {
          title = node.children[0]?.value || title;
        }
      }
    });
    visit(tree, "mdxJsxFlowElement", (node) => {
      if (node.name === "code") {
        const src = node.attributes.find(
          (attr) => attr.name === "src"
        )?.value;
        if (!src) {
          return;
        }
        const currtentMode = node.attributes.find(
          (attr) => attr.name === "previewMode"
        )?.value ?? previewMode;
        let isMobileMode = node.attributes.find(
          (attr) => attr.name === "isMobile"
        )?.value;
        if (isMobileMode === void 0) {
          isMobileMode = currtentMode === "iframe";
        } else if (isMobileMode === null) {
          isMobileMode = true;
        } else if (typeof isMobileMode === "object") {
          isMobileMode = isMobileMode.value !== "false";
        } else {
          isMobileMode = isMobileMode !== "false";
        }
        const id = generateId(pageName, index++);
        constructDemoNode(id, src, node, isMobileMode, externalDemoIndex++);
      }
    });
    visit(tree, "code", (node) => {
      if ("hasVisited" in node) {
        return;
      }
      if (node.lang && previewLanguages.includes(node.lang)) {
        if (node?.meta?.includes("pure") || !node?.meta?.includes("preview") && defaultRenderMode === "pure") {
          return;
        }
        const value = injectDemoBlockImport(
          previewCodeTransform({
            language: node.lang,
            code: node.value
          }),
          demoBlockComponentPath
        );
        const isMobileMode = node?.meta?.includes("mobile") || node?.meta?.includes("iframe") || !node?.meta?.includes("web") && !node?.meta?.includes("internal") && previewMode === "iframe";
        const id = generateId(pageName, index++);
        const virtualModulePath = (0, import_path2.join)(virtualDir, `${id}.tsx`);
        constructDemoNode(id, virtualModulePath, node, isMobileMode);
        if (import_fs_extra.default.existsSync(virtualModulePath)) {
          const content = import_fs_extra.default.readFileSync(virtualModulePath, "utf-8");
          if (content === value) {
            return;
          }
        }
        import_fs_extra.default.writeFileSync(virtualModulePath, value);
      }
    });
    tree.children.unshift(...demoMdx);
    if (demos[pageName].length > 0) {
      data.pageMeta.haveDemos = true;
    }
  };
};

// src/generate-entry.ts
var import_path3 = require("path");
var import_fs = require("fs");
function generateEntry(demos2, framework, position) {
  const sourceEntry = {};
  const entryCssPath = (0, import_path3.join)(staticPath, "global-styles", "entry.css");
  if (position === "follow") {
    Object.values(demos2).forEach((routes) => {
      routes.forEach((route) => {
        const { id, path: demoPath } = route;
        const entry = (0, import_path3.join)(virtualDir, `${id}.entry.tsx`);
        const solidEntry = `
        import { render } from 'solid-js/web';
        import ${JSON.stringify(entryCssPath)};
        import Demo from ${JSON.stringify(demoPath)};
        render(() => <Demo />, document.getElementById('root'));
        `;
        const reactEntry = `
        import { render } from 'react-dom';
        import ${JSON.stringify(entryCssPath)};
        import Demo from ${JSON.stringify(demoPath)};
        render(<Demo />, document.getElementById('root'));
        `;
        const entryContent = framework === "react" ? reactEntry : solidEntry;
        (0, import_fs.writeFileSync)(entry, entryContent);
        sourceEntry[id] = entry;
      });
    });
  } else {
    Object.entries(demos2).forEach(([key, routes]) => {
      if (routes.length === 0) {
        return;
      }
      const reactContent = `
        import { render } from 'react-dom';
        import ${JSON.stringify(entryCssPath)};
        ${routes.map((demo, index) => {
        return `import Demo_${index} from ${JSON.stringify(demo.path)}`;
      }).join("\n")}
        function App() {
          return (
            <div className="preview-container">
              <div className="preview-nav">{"${routes[0].title}"}</div>
              ${routes.map((demo, index) => {
        return `<Demo_${index} />`;
      }).join("\n")}
            </div>
          )
        }
        render(<App /> , document.getElementById('root'));
      `;
      const solidContent = `
        import { render } from 'solid-js/web';
        import ${JSON.stringify(entryCssPath)};
        ${routes.map((demo, index) => {
        return `import Demo_${index} from ${JSON.stringify(demo.path)}`;
      }).join("\n")}
        function App() {
          return (
            <div class="preview-container">
              <div class="preview-nav">{"${routes[0].title}"}</div>
              ${routes.map((_, index) => {
        return `<Demo_${index} />`;
      }).join("\n")}
            </div>
          )
        }
        render(() => <App /> , document.getElementById('root'));
      `;
      const renderContent = framework === "solid" ? solidContent : reactContent;
      const id = `_${toValidVarName(key)}`;
      const entry = (0, import_path3.join)(virtualDir, `${id}.entry.tsx`);
      (0, import_fs.writeFileSync)(entry, renderContent);
      sourceEntry[id] = entry;
    });
  }
  return sourceEntry;
}

// src/index.ts
var routeMeta;
var DEFAULT_PREVIEW_LANGUAGES = ["jsx", "tsx"];
function pluginPreview(options) {
  const {
    isMobile = false,
    iframeOptions = {},
    iframePosition = "follow",
    defaultRenderMode = "preview",
    previewLanguages = DEFAULT_PREVIEW_LANGUAGES,
    previewCodeTransform = ({ code }) => code
  } = options ?? {};
  const previewMode = options?.previewMode ?? isMobile ? "iframe" : "internal";
  const {
    devPort = 7890,
    framework = "react",
    position = iframePosition,
    builderConfig = {}
  } = iframeOptions;
  const globalUIComponents = position === "fixed" ? [(0, import_path4.join)(staticPath, "global-components", "Device.tsx")] : [];
  const getRouteMeta = () => routeMeta;
  let lastDemos;
  let devServer;
  let clientConfig;
  const port = devPort;
  return {
    name: "@rspress/plugin-preview",
    config(config) {
      config.markdown = config.markdown || {};
      config.markdown.mdxRs = false;
      return config;
    },
    routeGenerated(routes) {
      routeMeta = routes;
    },
    async beforeBuild(_, isProd) {
      if (!isProd) {
        try {
          await new Promise((resolve2, reject) => {
            const server = import_node_net.default.createServer();
            server.unref();
            server.on("error", reject);
            server.listen({ port, host: "0.0.0.0" }, () => {
              server.close(resolve2);
            });
          });
        } catch (e) {
          if (e.code !== "EADDRINUSE") {
            throw e;
          }
          throw new Error(
            `Port "${port}" is occupied, please choose another one.`
          );
        }
      }
    },
    async afterBuild(config, isProd) {
      if ((0, import_lodash.isEqual)(demos, lastDemos)) {
        return;
      }
      lastDemos = (0, import_lodash.cloneDeep)(demos);
      await devServer?.server?.close();
      const sourceEntry = generateEntry(demos, framework, position);
      const outDir = (0, import_path4.join)(config.outDir ?? "doc_build", "~demo");
      if (Object.keys(sourceEntry).length === 0) {
        return;
      }
      const { html, source, output, performance } = clientConfig ?? {};
      const rsbuildConfig = (0, import_core.mergeRsbuildConfig)(
        {
          dev: {
            progressBar: false
          },
          server: {
            port: devPort,
            printUrls: () => void 0,
            strictPort: true
          },
          performance: {
            ...performance,
            printFileSize: false
          },
          html,
          source: {
            ...source,
            entry: sourceEntry
          },
          output: {
            ...output,
            assetPrefix: output?.assetPrefix ? `${(0, import_shared3.removeTrailingSlash)(output.assetPrefix)}/~demo` : "/~demo",
            distPath: {
              root: outDir
            },
            // not copy files again
            copy: void 0
          },
          plugins: config?.builderPlugins
        },
        builderConfig
      );
      const rsbuildInstance = await (0, import_core.createRsbuild)({
        rsbuildConfig
      });
      if (framework === "solid") {
        rsbuildInstance.addPlugins([
          (0, import_plugin_babel.pluginBabel)({
            include: /\.(?:jsx|tsx)$/
          }),
          (0, import_plugin_solid.pluginSolid)()
        ]);
      }
      if (framework === "react") {
        rsbuildInstance.addPlugins([(0, import_plugin_react.pluginReact)()]);
      }
      if (isProd) {
        rsbuildInstance.build();
      } else {
        devServer = await rsbuildInstance.startDevServer();
      }
    },
    builderConfig: {
      source: {
        include: [(0, import_path4.join)(__dirname, "..")]
      },
      tools: {
        bundlerChain(chain) {
          chain.module.rule("Raw").resourceQuery(/raw/).type("asset/source").end();
          chain.resolve.extensions.prepend(".md").prepend(".mdx");
        }
      },
      plugins: [
        {
          name: "close-demo-server",
          setup: (api) => {
            api.modifyRsbuildConfig((config) => {
              if (config.output?.targets?.every((target) => target === "web")) {
                clientConfig = config;
              }
            });
            api.onCloseDevServer(async () => {
              await devServer?.server?.close();
            });
          }
        }
      ]
    },
    extendPageData(pageData, isProd) {
      if (!isProd) {
        pageData.devPort = port;
      }
    },
    markdown: {
      remarkPlugins: [
        [
          remarkCodeToDemo,
          {
            getRouteMeta,
            position,
            previewMode,
            defaultRenderMode,
            previewLanguages,
            previewCodeTransform
          }
        ]
      ],
      globalComponents: [
        (0, import_path4.join)(staticPath, "global-components", "Container.tsx")
      ]
    },
    globalUIComponents,
    globalStyles: (0, import_path4.join)(staticPath, "global-styles", `${previewMode}.css`)
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  pluginPreview
});

//# sourceMappingURL=index.js.map