"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils.ts
var utils_exports = {};
__export(utils_exports, {
  generateId: () => generateId,
  injectDemoBlockImport: () => injectDemoBlockImport,
  normalizeId: () => normalizeId,
  toValidVarName: () => toValidVarName
});
module.exports = __toCommonJS(utils_exports);
var toValidVarName = (str) => {
  if (/^[a-zA-Z_$][0-9a-zA-Z_$]*$/.test(str)) {
    return str;
  }
  return str.replace(/[^0-9a-zA-Z_$]/g, "_").replace(/^([0-9])/, "_$1");
};
var generateId = (pageName, index) => {
  return `_${toValidVarName(pageName)}_${index}`;
};
var normalizeId = (routePath) => {
  const result = routePath.replace(/\.(.*)?$/, "");
  return toValidVarName(result);
};
var injectDemoBlockImport = (str, path) => {
  return `
    import DemoBlock from ${JSON.stringify(path)};
    ${str}
  `;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  generateId,
  injectDemoBlockImport,
  normalizeId,
  toValidVarName
});

//# sourceMappingURL=utils.js.map